/* ------------------------------------------------------------

   Contains the global declares for the query engine
   expressed as externs for the secomdary modules.

   See the file "declares.h" for more details.

------------------------------------------------------------ */

/* used by input and get_token() */
extern char line[BUFSIZ];
extern char *ptr;

/* used by parsing routines */

/* for get_token() */

extern int token, token_value;	
extern char *startptr, token_string [BUFSIZ];

/* used for one token look ahead */

extern int last_token, last_token_value;
extern char *last_token_string[BUFSIZ];

/* used by parse_term() */

extern struct term_type *termptr, term;

/* used by parse_query() */

extern struct query_type *qptr, query;



/* a single query consists of one of more terms with
   associated constraints on that search.   */


struct query_type {
	struct term_type *termptr;
	int command_type;
	char constraints[BUFSIZ];
	char version[BUFSIZ];
	};


/* each term is some set of the following.  */

struct term_type {
	int command;
	int command_type;
	char constraints[BUFSIZ];
	char attribute[BUFSIZ];
	char value[BUFSIZ];
	struct term_type *nextptr;
	};



